# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_contains = "seadrive"
kb_fname = "Windows6.1-KB3033929-x64.msu"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://www.seafile.com/en/download/"
    bin_name_sub = bin_contains + "-%s.exe"
    url_dl_kb = "https://download.microsoft.com/download/C/8/7/C87AE67E-A228-48FB-8F02-B2A9A1238099/Windows6.1-KB3033929-x64.msu"

    # Getting latest version from official website
    for bs_search in bs_find_all(url, "a", "class", "download-op", proxies=proxies):
        latest_bin = bs_search["href"].split("/")[-1]
        if latest_bin.startswith(bin_contains) and latest_bin.endswith(".exe"):
            url_dl = bs_search["href"]
            version = bs_search.string
            break

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        if Version(version) != Version(version_from_file) and version_from_file != "":
            print("Changing version to the version number of the binary (from: %s to: %s)" % (version, version_from_file))
            os.rename(latest_bin, bin_name_sub % version_from_file)
            version = version_from_file

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(Version(version))
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Downloading KB
    if not isfile(kb_fname):
        print("Downloading: %s" % kb_fname)
        # wget(url_dl_kb,kb_fname,proxies=proxies)

    # Validating or not update-package-sources
    return result
